# class Vector3D

#### package openfl.geom

Available on all platforms

### Constructor

###

`new (x:Float = 0, y:Float = 0, z:Float = 0, w:Float = 0)`

### Variables

###

`read onlywrite onlylength:Float`

###

`read onlywrite onlylengthSquared:Float`

###

`w:Float`

###

`x:Float`

###

`y:Float`

###

`z:Float`

### Methods

###

`add (a:Vector3D):Vector3D`

###

`clone ():Vector3D`

###

`copyFrom (sourceVector3D:Vector3D):Void`

###

`crossProduct (a:Vector3D):Vector3D`

###

`decrementBy (a:Vector3D):Void`

###

`dotProduct (a:Vector3D):Float`

###

`equals (toCompare:Vector3D, allFour:Bool = false):Bool`

###

`incrementBy (a:Vector3D):Void`

###

`nearEquals (toCompare:Vector3D, tolerance:Float, allFour:Bool = false):Bool`

###

`negate ():Void`

###

`normalize ():Float`

###

`project ():Void`

###

`scaleBy (s:Float):Void`

###

`setTo (xa:Float, ya:Float, za:Float):Void`

###

`subtract (a:Vector3D):Vector3D`

###

`toString ():String`

### Static variables

###

`staticread onlywrite onlyX_AXIS:Vector3D`

###

`staticread onlywrite onlyY_AXIS:Vector3D`

###

`staticread onlywrite onlyZ_AXIS:Vector3D`

### Static methods

###

`staticangleBetween (a:Vector3D, b:Vector3D):Float`

###

`staticdistance (pt1:Vector3D, pt2:Vector3D):Float`